
module DYAutomate
  class Command
    class CodeSnippet < Command

      require "fileutils"

      self.abstract_command = false
      self.command = 'snippet'
      self.summary = '拷贝代码片段到Xcode中'
      # self.default_subcommand = 'list'
      self.arguments = [
          # CLAide::Argument.new('NAME',   true),
      ]

      #当前路径
      attr_accessor :xcode_snippsets_path

      def initialize(argv)
        super
        @xcode_snippsets_path = File.join(Dir.home,"/Library/Developer/Xcode/UserData/CodeSnippets")
      end

      def validate!
        super
        unless Dir.exist?(@xcode_snippsets_path)
          help! "
            error -- >!!! Not found Xcode CodeSnippets at the #{@xcode_snippsets_path}"
        end

        unless @config.detailObj.codeSnippsets_git_url
          help! "
            error -- >!!! Not found the value of codeSnippsets_git_url"
        end
      end

      def run
        clone_templates
      end

      def clone_templates
        tempPath = File.join(Dir.home,'Documents','.iOSCodeSnippet')
        unless Dir.exist?(tempPath)
          system("mkdir #{tempPath}")
        end
        system ("git clone #{@config.codeSnippsets_git_url} --depth 1 #{tempPath}")
        Dir.chdir("#{tempPath}/CodeSnippets")
        Dir.glob("*") do |path|
          FileUtils.cp(path, @xcode_snippsets_path)
        end
        `rm -rf #{tempPath}`
        puts "安装完成..."
      end

    end
  end
end
