module DYAutomate
  class Command
    class Pod < Command

      require 'Command/pod/push.rb'
      require 'Command/pod/version.rb'

      self.abstract_command = true
      self.command = 'pod'
      self.summary = '私有库的相关操作'
      # self.default_subcommand = 'list'
      self.arguments = [
          # CLAide::Argument.new('NAME',   true),
      ]

      #lib名字
      attr_accessor :name
      #当前路径
      attr_accessor :path

      # spec文件路径
      attr_accessor :spec_path
      # #查询结果lib信息
      attr_accessor :spec_name

      def initialize(argv)
        super
        @path = Dir.pwd
        pp("当前环境变量 #{@env_str}",1)
      end

      def validate!
        super
        unless existPodspec?
          help! "
          error -- >!!! has no podspec file at #{@path}"
        else
          puts "find podspec" + "#{@spec_path}"
        end
      end

      def run
        pp('pod run ...',1)
      end

      #podspec文件是否存在
      def existPodspec?
        exist = false
        Dir.entries(@path).each{ |d|
          if d.to_s =~ /.podspec/
            exist = true
            @spec_path = File.join(@path,d.to_s)
            @spec_name = d.to_s
            @name = d.to_s.split('.')[0]
            break
          end
        }
        exist
      end

      #查找spec中版本号
      def get_spec_version
        #查找文本
        targetLine = file_line_match(@spec_path,/s.version *=/)
        match = targetLine.match(/'[\d].[\d]*.[\d]*'/)
        v = ''
        if match
          v = match.to_s.gsub(/'/,'')
        end
        v
      end

      # 1.1.1 => 1.1.2
      def get_version_new
        new_v = ''
        cur_v = get_spec_version
        pp(cur_v,1)
        if cur_v && cur_v.size > 0
          new_v = cur_v.split('.').map.with_index{|x,i|
            if i == 2
              x.to_i + 1
            else
              x
            end
          }.join('.')
        end
        pp("get_version_new ==  #{new_v}",1)
        new_v
      end

      # 1.1.1 => 1.2.0
      def get_version_big_new
        new_v = ''
        cur_v = get_spec_version
        pp(cur_v,1)
        if cur_v && cur_v.size > 0
          new_v = cur_v.split('.').map.with_index{|x,i|
            if i == 1
              x.to_i + 1
            elsif i == 2
              0
            else
              x
            end
          }.join('.')
        end
        pp("get_version_big_new ==  #{new_v}",1)
        new_v
      end


      #文本文件查找内容
      def file_line_match(path,reg)
        pp('file_line_match ...' + path ,1)
        targetLine = ''
        File.open(path,"r+") do |file| #r:utf-8表示以utf-8编码读取文件，要与当前代码文件的编码相同
            file.each_line {|line|
              puts line
              if line =~ reg
                targetLine = line
                break
              end
            }
        end
        pp('file_line_match..end --' + targetLine,1)
        targetLine
      end

      #文本文件替换某一行中文本
      def file_line_match_replace(path,reg,newline)
        filePath = path
        #查找要替换的文本
        targetLine = file_line_match(filePath,reg)

        #替换内容
        content = File.read(filePath)
        newContent = content.gsub(targetLine, newline)

        #覆盖内容
        File.open(filePath,"w+") do |file| #r:utf-8表示以utf-8编码读取文件，要与当前代码文件的编码相同
          file.write(newContent)
          file.close
        end
      end

      #更新repo
      def dy_update_repo
        path = File.join(Dir.home,'.cocoapods/repos')
        excludeFiles = [".","..",".DS_Store",'master','trunk']
        Dir.entries(path).each do |subDir|
          puts subDir
          unless excludeFiles.include?(subDir)
            system "#{@env_str} pod repo update #{subDir}"
          end
        end
      end

    end
  end
end
