module DYAutomate
  class Command
    class WorkSpace < Command
      require 'Command/WorkSpace/update.rb'
      require 'Command/WorkSpace/install.rb'

      self.abstract_command = true
      self.command = 'ws'
      self.summary = '项目工程workspace的相关操作'
      # self.default_subcommand = 'list'
      self.arguments = [
          # CLAide::Argument.new('NAME',   true),
      ]

      def self.options
        [
          ['--silent', 'Show nothing'],
        ].concat(super)
      end

      #lib名字
      attr_accessor :name
      #当前路径
      attr_accessor :path

      # spec文件路径
      attr_accessor :project_path
      # #查询结果lib信息
      attr_accessor :workSpace_path

      # 是否静默
      attr_accessor :isSilent

      def initialize(argv)
        # @path = '/Users/cw/Documents/Dy/Apps/doing/doing'
        super
        @path = Dir.pwd
        @isSilent = argv.flag?("silent")
        puts "env == #{@env_str}"
      end

      def validate!
        super
        unless existProject?
          help! "
          error -- >has no project file at -->  #{@path}"
        else
          pp("find project at -->#{@project_path}",1)
        end

        # unless existWorkSpace?
        #   help! "!!! has no xcworkspace file at --> #{@path}"
        # else
        #   pp("find xcworkspace at --> " + "#{@workSpace_path}",1)
        # end
      end

      def run
        pp('WorkSpace run ...',1)
        pp("当前环境变量 #{@env_str}",1)
      end

      #project文件是否存在
      def existProject?
        exist = false
        Dir.entries(@path).each{ |d|
          if d.to_s =~ /.xcodeproj/
            exist = true
            @project_path = File.join(@path,d.to_s)
            # @spec_name = d.to_s
            @name = d.to_s.split('.')[0]
            break
          end
        }
        exist
      end

      #workspace文件是否存在
      def existWorkSpace?
        exist = false
        Dir.entries(@path).each{ |d|
          if d.to_s =~ /.xcworkspace/
            exist = true
            @workSpace_path = File.join(@path,d.to_s)
            break
          end
        }
        exist
      end

      #更新repo
      def dy_update_repo
        path = File.join(Dir.home,'.cocoapods/repos')
        excludeFiles = [".","..",".DS_Store",'master','trunk']
        Dir.entries(path).each do |subDir|
          puts subDir
          unless excludeFiles.include?(subDir)
            system "#{@env_str} pod repo update #{subDir}"
          end
        end
      end

    end
  end
end
